commit e6dcc14640105d2daf9c7f279980543470be7866
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Mon Dec 20 22:12:33 2021

    Fortran: BOZ literal constants are not interoperable
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103778
            * check.c (is_c_interoperable): A BOZ literal constant is not
            interoperable.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103778
            * gfortran.dg/illegal_boz_arg_3.f90: New test.
    
    (cherry picked from commit ff0ad4b5e16b8828a6147ae2d5fec8068ef0778e)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index 6341756bf3e..e110ca01f2f 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -5181,6 +5181,12 @@ is_c_interoperable (gfc_expr *expr, const char **msg, bool c_loc, bool c_f_ptr)
       return false;
     }
 
+  if (expr->ts.type == BT_BOZ)
+    {
+      *msg = "BOZ literal constant";
+      return false;
+    }
+
   if (expr->ts.type == BT_CLASS)
     {
       *msg = "Expression is polymorphic";
diff --git a/gcc/testsuite/gfortran.dg/illegal_boz_arg_3.f90 b/gcc/testsuite/gfortran.dg/illegal_boz_arg_3.f90
new file mode 100644
index 00000000000..59fefa90971
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/illegal_boz_arg_3.f90
@@ -0,0 +1,7 @@
+! { dg-do compile }
+! PR fortran/103778
+
+program p
+  use iso_c_binding, only : c_sizeof
+  integer, parameter :: a = c_sizeof(z'1') ! { dg-error "cannot appear" }
+end

